From 7c6ac7195e06a705011e7d9a96818034f05fe98f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 00:24:32 +0000
Subject: [PATCH 1117/2232] Add copy assignment operator for Error


---

diff --git a/include/cxx.h b/include/cxx.h
index adbc8e6..d43854c 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -257,6 +257,9 @@ public:
   Error(const Error &);
   Error(Error &&) noexcept;
   ~Error() noexcept;
+
+  Error &operator=(const Error &);
+
   const char *what() const noexcept override;
 
 private:
diff --git a/src/cxx.cc b/src/cxx.cc
index 0fba35c..7843b29 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -184,6 +184,17 @@ Error::Error(Error &&other) noexcept
 
 Error::~Error() noexcept { delete[] this->msg; }
 
+Error &Error::operator=(const Error &other) {
+  if (this != &other) {
+    std::exception::operator=(other);
+    delete[] this->msg;
+    this->msg = nullptr;
+    this->msg = cxxbridge05$error(other.msg, other.len);
+    this->len = other.len;
+  }
+  return *this;
+}
+
 const char *Error::what() const noexcept { return this->msg; }
 
 } // namespace cxxbridge05

